<?php
require_once 'Credenziali.php';

// crea tutti i files "x_PROVAX00X00X000Y.txt" per openssl, controlla cf con check digit

define ("_Fatture730", "Fatture730_2015_completo");     // nome del file da trattare ( .txt, .xml, .zip )
error_log("File trattato          : "._Fatture730.".txt", 0);

$file = fopen(_Fatture730.".txt", "r");

echo "<table border=4 cellpadding=4>";
while( !feof($file) )
    {
    $row = fgets($file);
    $col = explode(";", $row);
    if ( !empty($col[_ColFiscalCode]) )
        {
        file_put_contents("FC/x_".$col[_ColFiscalCode].".txt", $col[_ColFiscalCode], FILE_USE_INCLUDE_PATH)
            or die("Unable put ".$col[_ColFiscalCode]." to file");

        $cf = codicefiscale($col[_ColFiscalCode]);
        if ( !empty($cf) )
            {
            error_log($col[_ColDocNumber]." * ".$col[_ColFiscalCode]." * ".$cf, 0);
            }

        $TotalEuro = $col[_ColTotalEuro] - $col[_ColNotRelevant1] - $col[_ColNotRelevant2] - $col[_ColNotRelevant3];
        if ( $TotalEuro <= 0 )
            {
            error_log($col[_ColDocNumber]." * FATTURA CON IMPORTO ZERO", 0);
            }

        echo "<tr>";
        echo "<td>".$col[_ColFiscalCode]."</td>";
        echo "<td>".$col[_ColDocNumber]."</td>";
        echo "<td>".$col[_ColDocDate]."</td>";
        echo "<td>".$TotalEuro."</td>";
        echo "<td>".$cf."</td>";
        echo "</tr>";
        }
    }
echo "</table>";

fclose($file);

error_log("done ".$_SERVER['PHP_SELF'], 0);


function codicefiscale($cf){
  if( preg_match("/^[A-Z0-9]+\$/", $cf) != 1 )
    return "Il codice fiscale contiene dei caratteri non validi (sono valide lettere e cifre)";

  static $CFcalc = array(
    '0' => 1,
    '1' => 0,
    '2' => 5,
    '3' => 7,
    '4' => 9,
    '5' => 13,
    '6' => 15,
    '7' => 17,
    '8' => 19,
    '9' => 21,
    'A' => 1,
    'B' => 0,
    'C' => 5,
    'D' => 7,
    'E' => 9,
    'F' => 13,
    'G' => 15,
    'H' => 17,
    'I' => 19,
    'J' => 21,
    'K' => 2,
    'L' => 4,
    'M' => 18,
    'N' => 20,
    'O' => 11,
    'P' => 3,
    'Q' => 6,
    'R' => 8,
    'S' => 12,
    'T' => 14,
    'U' => 16,
    'V' => 10,
    'W' => 22,
    'X' => 25,
    'Y' => 24,
    'Z' => 23,
    'end' => 'end'
  );

  $s = 0;
  for( $i = 1; $i <= 13; $i += 2 )
    {
    $c = $cf[$i];
    if( strcmp($c, "0") >= 0 and strcmp($c, "9") <= 0 )
      $s += ord($c) - ord('0');
    else
      $s += ord($c) - ord('A');
    }
  for( $i = 0; $i <= 14; $i += 2 )
    {
    $c = $cf[$i];
    $s += $CFcalc[$c];
    }
  if( chr($s%26 + ord('A')) != $cf[15] ) 
    return "Il codice fiscale NON &egrave; riconosciuto ". chr($s%26 + ord('A'));
  return "";
}
?>
